#!/bin/bash
# 2020 (c) Muntashir Al-Islam. All rights reserved.
# Source: https://chromium.googlesource.com/aosp/platform/system/update_engine/+/master/common/constants.h
# Fetched 1 Jan 2020

kPowerwashSafePrefsSubDirectory="update_engine/prefs"
kPrefsSubDirectory="prefs"
kPostinstallDefaultScript="postinst"
kStatefulPartition="/mnt/stateful_partition"

# Constants defining keys for the persisted state of update engine.
kPrefsAttemptInProgress="attempt-in-progress"
kPrefsBackoffExpiryTime="backoff-expiry-time"
kPrefsBootId="boot-id"
kPrefsCurrentBytesDownloaded="current-bytes-downloaded"
kPrefsCurrentResponseSignature="current-response-signature"
kPrefsCurrentUrlFailureCount="current-url-failure-count"
kPrefsCurrentUrlIndex="current-url-index"
kPrefsDailyMetricsLastReportedAt="daily-metrics-last-reported-at"
kPrefsDeltaUpdateFailures="delta-update-failures"
kPrefsDynamicPartitionMetadataUpdated="dynamic-partition-metadata-updated"
kPrefsFullPayloadAttemptNumber="full-payload-attempt-number"
kPrefsInstallDateDays="install-date-days"
kPrefsLastActivePingDay="last-active-ping-day"
kPrefsLastRollCallPingDay="last-roll-call-ping-day"
kPrefsManifestMetadataSize="manifest-metadata-size"
kPrefsManifestSignatureSize="manifest-signature-size"
kPrefsMetricsAttemptLastReportingTime="metrics-attempt-last-reporting-time"
kPrefsMetricsCheckLastReportingTime="metrics-check-last-reporting-time"
kPrefsNoIgnoreBackoff="no-ignore-backoff"
kPrefsNumReboots="num-reboots"
kPrefsNumResponsesSeen="num-responses-seen"
kPrefsOmahaCohort="omaha-cohort"
kPrefsOmahaCohortHint="omaha-cohort-hint"
kPrefsOmahaCohortName="omaha-cohort-name"
kPrefsOmahaEolDate="omaha-eol-date"
kPrefsP2PEnabled="p2p-enabled"
kPrefsP2PFirstAttemptTimestamp="p2p-first-attempt-timestamp"
kPrefsP2PNumAttempts="p2p-num-attempts"
kPrefsPayloadAttemptNumber="payload-attempt-number"
kPrefsPostInstallSucceeded="post-install-succeeded"
kPrefsPreviousVersion="previous-version"
kPrefsResumedUpdateFailures="resumed-update-failures"
kPrefsRollbackHappened="rollback-happened"
kPrefsRollbackVersion="rollback-version"
kPrefsChannelOnSlotPrefix="channel-on-slot-"
kPrefsSystemUpdatedMarker="system-updated-marker"
kPrefsTargetVersionAttempt="target-version-attempt"
kPrefsTargetVersionInstalledFrom="target-version-installed-from"
kPrefsTargetVersionUniqueId="target-version-unique-id"
kPrefsTotalBytesDownloaded="total-bytes-downloaded"
kPrefsUpdateCheckCount="update-check-count"
kPrefsUpdateCheckResponseHash="update-check-response-hash"
kPrefsUpdateCompletedBootTime="update-completed-boot-time"
kPrefsUpdateCompletedOnBootId="update-completed-on-boot-id"
kPrefsUpdateDurationUptime="update-completed-on-boot-id"
kPrefsUpdateFirstSeenAt="update-first-seen-at"
kPrefsUpdateOverCellularPermission="update-over-cellular-permission"
kPrefsUpdateOverCellularTargetVersion="update-over-cellular-target-version"
kPrefsUpdateOverCellularTargetSize="update-over-cellular-target-size"
kPrefsUpdateServerCertificate="update-server-cert"
kPrefsUpdateStateNextDataLength="update-state-next-data-length"
kPrefsUpdateStateNextDataOffset="update-state-next-data-offset"
kPrefsUpdateStateNextOperation="update-state-next-operation"
kPrefsUpdateStatePayloadIndex="update-state-payload-index"
kPrefsUpdateStateSHA256Context="update-state-sha-256-context"
kPrefsUpdateStateSignatureBlob="update-state-signature-blob"
kPrefsUpdateStateSignedSHA256Context="update-state-signed-sha-256-context"
kPrefsUpdateBootTimestampStart="update-boot-timestamp-start"
kPrefsUpdateTimestampStart="update-timestamp-start"
kPrefsUrlSwitchCount="url-switch-count"
kPrefsVerityWritten="verity-written"
kPrefsWallClockScatteringWaitPeriod="wall-clock-wait-period"
kPrefsWallClockStagingWaitPeriod="wall-clock-staging-wait-period"

# These four fields are generated by scripts/brillo_update_payload.
kPayloadPropertyFileSize="FILE_SIZE"
kPayloadPropertyFileHash="FILE_HASH"
kPayloadPropertyMetadataSize="METADATA_SIZE"
kPayloadPropertyMetadataHash="METADATA_HASH"

# The Authorization: HTTP header to be sent when downloading the payload.
kPayloadPropertyAuthorization="AUTHORIZATION"
# The User-Agent HTTP header to be sent when downloading the payload.
kPayloadPropertyUserAgent="USER_AGENT"
# Set "POWERWASH=1" to powerwash (factory data reset) the device after applying the update.
kPayloadPropertyPowerwash="POWERWASH"
# The network id to pass to android_setprocnetwork before downloading.
kPayloadPropertyNetworkId="NETWORK_ID"
# Set "SWITCH_SLOT_ON_REBOOT=0" to skip marking the updated partitions active. The default is 1 (always switch slot if update succeeded).
kPayloadPropertySwitchSlotOnReboot="SWITCH_SLOT_ON_REBOOT"
# Set "RUN_POST_INSTALL=0" to skip running post install. Default is 1
kPayloadPropertyRunPostInstall="RUN_POST_INSTALL"

kOmahaUpdaterVersion="0.1.0.0"

# X-Goog-Update headers.
kXGoogleUpdateInteractivity="X-Goog-Update-Interactivity"
kXGoogleUpdateAppId="X-Goog-Update-AppId"
kXGoogleUpdateUpdater="X-Goog-Update-Updater"
kXGoogleUpdateSessionId="X-Goog-SessionId"

# enum DownloadSource
kDownloadSourceHttpsServer=1  # UMA Binary representation: 0001
kDownloadSourceHttpServer=2   # UMA Binary representation: 0010
kDownloadSourceHttpPeer=4     # UMA Binary representation: 0100
kNumDownloadSources=8

# enum PayloadType
kPayloadTypeFull=0
kPayloadTypeDelta=1
kPayloadTypeForcedFull=2
kNumPayloadTypes=3

kMaxP2PAttempts=10
kMaxP2PAttemptTimeSeconds=$(( 5 * 24 * 60 * 60 ))
kMaxP2PNetworkWaitTimeSeconds=$(( 6 * 60 * 60))
kMaxP2PFilesToKeep=3
kMaxP2PFileAgeDays=5
kNumDefaultUmaBuckets=50
kNumBytesInOneMiB=$(( 1024 * 1024 ))
kDownloadMaxRedirects=10
kDownloadLowSpeedLimitBps=1
kDownloadP2PLowSpeedLimitBps=$(( 25 * 1000 ))

kDownloadLowSpeedTimeSeconds=30
kDownloadDevModeLowSpeedTimeSeconds=180
kDownloadP2PLowSpeedTimeSeconds=60

kDownloadMaxRetryCount=20
kDownloadMaxRetryCountOobeNotComplete=3
kDownloadMaxRetryCountInteractive=3
kDownloadP2PMaxRetryCount=5

kDownloadConnectTimeoutSeconds=30
kDownloadP2PConnectTimeoutSeconds=5
